
####### Expanded from @PACKAGE_INIT@ by configure_package_config_file() #######
####### Any changes to this file will be overwritten by the next CMake run ####
####### The input file was nvpl-config.cmake.in                            ########

get_filename_component(PACKAGE_PREFIX_DIR "${CMAKE_CURRENT_LIST_DIR}/../../../" ABSOLUTE)

macro(set_and_check _var _file)
  set(${_var} "${_file}")
  if(NOT EXISTS "${_file}")
    message(FATAL_ERROR "File or directory ${_file} referenced by variable ${_var} does not exist !")
  endif()
endmacro()

macro(check_required_components _NAME)
  foreach(comp ${${_NAME}_FIND_COMPONENTS})
    if(NOT ${_NAME}_${comp}_FOUND)
      if(${_NAME}_FIND_REQUIRED_${comp})
        set(${_NAME}_FOUND FALSE)
      endif()
    endif()
  endforeach()
endmacro()

####################################################################################

# nvpl-config.cmake
#
# Supported Package COMPONENT Libraries:
# common;blas;fft;lapack;rand;scalapack;sparse;tensor
#
# Exported Variables
# * nvpl_COMPONENTS_FOUND - List of all found component libraries
# * nvpl_LOCATION - Install prefix of nvpl-common library
#

set(_nvpl_all_components common;blas;fft;lapack;rand;scalapack;sparse;tensor)
set(_nvpl ${CMAKE_FIND_PACKAGE_NAME})

if(NOT DEFINED ${${_nvpl}_VERSION})
    set(${_nvpl}_VERSION 25.5)
endif()


set(${_nvpl}_COMPONENTS_FOUND)
foreach(_cmp IN LISTS _nvpl_all_components)
    if(NOT nvpl_${_cmp}_FOUND)
        find_package(nvpl_${_cmp} QUIET
                     HINTS ${CMAKE_CURRENT_LIST_DIR}/..)
    endif()
    if(nvpl_${_cmp}_FOUND)
        if(NOT ${CMAKE_FIND_PACKAGE_NAME}_FIND_QUIETLY)
            find_package(nvpl_${_cmp})
        endif()
        list(APPEND ${_nvpl}_COMPONENTS_FOUND ${_cmp})
        set(${_nvpl}_${_cmp}_FOUND 1)
    endif()
endforeach()

# Check for invalid COMPONENTS specified
foreach(_cmp IN LISTS ${_nvpl}_FIND_COMPONENTS)
    if(NOT _cmp IN_LIST _nvpl_all_components)
        set(_msg "Package ${_nvpl} has no COMPONENT '${_cmp}'.")
        if(_cmp MATCHES "[A-Z]")
            string(APPEND _msg "  All COMPONENT names are lower-case.")
        elseif(_cmp MATCHES "blacs")
            string(APPEND _msg "  The 'scalapack' COMPONENT provides nvpl::blacs interfaces.")
        elseif(_cmp MATCHES "bla")
            string(APPEND _msg "  Did you mean 'blas'?")
        elseif(_cmp MATCHES "fft")
            string(APPEND _msg "  Did you mean 'fft'?")
        endif()
        list(JOIN _nvpl_all_components ", " _cmp_list)
        string(APPEND _msg "\nValid ${_nvpl} COMPONENT(s): [${_cmp_list}]")
        if(${_nvpl}_FIND_QUIETLY OR NOT ${_nvpl}_FIND_REQUIRED_${_cmp})
            message(WARNING "${_msg}")
        else()
            message(SEND_ERROR "${_msg}")
        endif()
        list(APPEND ${_nvpl}_UNKNOWN_COMPONENTS ${_cmp})
    endif()
endforeach()
unset(_cmp)
unset(_nvpl_all_components)

check_required_components(${_nvpl})

## Report status
if(NOT ${CMAKE_FIND_PACKAGE_NAME}_FIND_QUIETLY)
    list(JOIN ${_nvpl}_COMPONENTS_FOUND ", " _cmp_list)
    message(STATUS
    "Found ${_nvpl}: (Version:${${_nvpl}_VERSION}
                CMakePackageDir:${CMAKE_CURRENT_LIST_DIR}
                Component Libraries Found:[${_cmp_list}])")
    unset(_cmp_list)
endif()

unset(_nvpl)
